import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Dragon here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Dragon extends Actor
{
    //Sprites by JoshR691, found on Google
    private GreenfootImage dragon1 = new GreenfootImage("Charziard1.png");
    private GreenfootImage dragon2 = new GreenfootImage("Charziard2.png");
    private GreenfootImage dragon3 = new GreenfootImage("Charziard3.png");
    private GreenfootImage dragon4 = new GreenfootImage("Charziard4.png");
    private int frame = 1;
    private int animationCounter = 0;

    private int vSpeed = 0;
    private int acceleration = 1;
    private int flapStrength = 4;

    /**
     * Act - do whatever the Dragon wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        checkKey();
        fall();
        checkCeiling(); // Are we hitting the ceiling?
        checkBottom(); // Are we hitting the bottom?
        checkTower(); // Are we hitting the tower?
        animationCounter++;
        if (animationCounter == 4)
        {
            animationCounter = 0;
            animate();
        }
    } 
    
     public boolean checkCeiling()
    {
        if (getY() < 32)
        {
            Greenfoot.stop(); // Game Over
            ((MyWorld)getWorld()).endGame();
            return true;
        }
        else
        {
            return false;
        }
    }

    public boolean checkBottom()
    {
        if (getY() > 564) 
        {
            Greenfoot.stop(); // Game Over
            ((MyWorld)getWorld()).endGame();
            return true;
        }
        else
        {
            return false;
        }
    }

    public boolean checkTower()
    {
        int spriteWidth = getImage().getWidth();
        int xDistance = (int)(spriteWidth/2);
        Actor towerWall = getOneObjectAtOffset(xDistance, 0, Platform.class);
        if(towerWall == null)
        {
            return false;
        }
        else
        {
            Greenfoot.stop(); // Game Over
            ((MyWorld)getWorld()).endGame();
            return true;
        }
    }

    public void animate()
    {
        if (frame == 1)
        {
            setImage(dragon4);
        }
        else if (frame == 2)
        {
            setImage(dragon3);
        }
        else if (frame == 3)
        {
            setImage(dragon2);
        }
        else if (frame == 4)
        {
            setImage(dragon1);
            frame = 1;
            return;
        }
        frame++;
    }

    public void checkKey()
    {
        if (Greenfoot.isKeyDown("space") | Greenfoot.isKeyDown("up"))
        {
            flap();
        }
    }

    public void flap()
    { 
        if (vSpeed >= -9)
        {
            vSpeed = vSpeed - flapStrength;
        }
        fall();
    }

    public void fall()
    {
        setLocation(getX(), getY() + vSpeed);
        if (vSpeed <= 9)
        {
            vSpeed = vSpeed + acceleration;
        }
    }
}
